"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRootProvider = void 0;
var React = require("react");
var actionTypes_1 = require("./utils/actionTypes");
var createAction_1 = require("./createAction");
function createRootProvider(Context) {
    return function RootProvider(_a) {
        var children = _a.children;
        var defaultValue = React.useContext(Context);
        var _b = React.useReducer(defaultValue.reducer, defaultValue.state), state = _b[0], reducerDispatch = _b[1];
        React.useEffect(function initialiseReducer() {
            reducerDispatch(createAction_1.createAction(actionTypes_1.ActionTypes.INIT)());
        }, []);
        var dispatch = React.useCallback(function wrappedDispatch(action) {
            reducerDispatch(action);
            return action;
        }, [reducerDispatch]);
        var value = React.useMemo(function () { return (__assign(__assign({}, defaultValue), { dispatch: dispatch, state: state })); }, [defaultValue, dispatch, state]);
        return React.createElement(Context.Provider, { value: value }, children);
    };
}
exports.createRootProvider = createRootProvider;
