"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRootReducer = void 0;
function combineReducers(initialState, reducerMapping) {
    var reducers = Object.entries(reducerMapping);
    return function (state, action) {
        if (state === void 0) { state = initialState; }
        return reducers.reduce(function (acc, _a) {
            var name = _a[0], reducer = _a[1];
            acc[name] = reducer(state[name], action);
            return acc;
        }, {});
    };
}
function createRootReducer() {
    var ducks = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        ducks[_i] = arguments[_i];
    }
    var _a = ducks.reduce(function (acc, duck) {
        acc.reducerMapping[duck.name] = duck.reducer;
        acc.initialState[duck.name] = duck.initialState;
        return acc;
    }, { initialState: {}, reducerMapping: {} }), initialState = _a.initialState, reducerMapping = _a.reducerMapping;
    return combineReducers(initialState, reducerMapping);
}
exports.createRootReducer = createRootReducer;
